100   '******************************
110   '*  VISUAL SORT DEMO PROGRAM  *
120   '*                            *
130   '*     Don Ravey  -  1986     *
140   '*                            *
150   '******************************
200   '
1000  GOSUB INITIALIZE
1010  STYLE=2^2: GOSUB SETSTYLE   'Italic style
1020  GOTOXY 1,2: PRINT" Generating"N"random points..." SPACE$(10)
1030  STYLE=0:   GOSUB SETSTYLE   'Reset normal style
1040  GOSUB RANDARRAY
1045  '
1050  FOR S=0 TO 3
1060  OFFSET= 6 + S*150: GOSUB PLOTRAND
1070  FOR Z=1 TO N: V2%(Z)=V1%(Z): NEXT Z
1080  STYLE=2^0: GOSUB SETSTYLE   'Bold style
1090  GOTOXY (S*16)+3,4: PRINT SORTNAME$(S)
1100  STYLE=0:   GOSUB SETSTYLE   'Reset normal style
1110  GOSUB READY: PRINT CHR$(7)
1115  '
1200  ON S+1 GOSUB BUBBLE, INSERTION, SHELL, QUICK
1205  '
1210  GOSUB SND
1220  NEXT S
1225  '
1230  PARM=106: STYLE=0: GOSUB SETSTYLE  'Restore normal print style
1250  GOTOXY 1,2: INPUT "Press [RETURN] to return to BASIC: ", X$
1260  END
1500  '******************************
1600  '       S U B R O U T I N E S :
2000  '------------------------------
2010  BUBBLE:
2020  FOR X=2 TO N
2030  FLAG=0
2040  FOR Z=1 TO N-1
2050  IF V2%(Z) > V2%(Z+1) THEN Y=Z+1: GOSUB SWITCH: FLAG=1
2060  NEXT Z
2070  IF FLAG=0 THEN X=N
2080  NEXT X
2090  RETURN
3000  '------------------------------
3010  INSERTION:
3020  FOR X=2 TO N
3030  T%=V2%(X): A=X: GOSUB UNPLOT
3040  FOR Y=X-1 TO 1 STEP -1
3050  IF T% > V2%(Y) THEN V2%(Y+1)=T%: A=Y+1: GOSUB PLOT: GOTO 3090
3060  V2%(Y+1)=V2%(Y): A=Y: GOSUB UNPLOT: A=Y+1: GOSUB PLOT
3070  NEXT Y
3080  V2%(1)=T%: A=1: GOSUB PLOT
3090  NEXT X
3100  RETURN
4000  '------------------------------
4010  SHELL:
4020  D=2^INT(LOG(N)/LOG(2))-1
4030  FOR Y=1 TO N-D
4040  IF V2%(Y) <= V2%(Y+D) THEN 4120
4050  T%=V2%(Y+D): A=Y+D: GOSUB UNPLOT
4055  V2%(Y+D)=V2%(Y): A=Y: GOSUB UNPLOT: A=Y+D: GOSUB PLOT
4060  IF Y <= D THEN V2%(Y)=T%: A=Y: GOSUB PLOT: GOTO 4120
4070  FOR Z=Y-D TO 1 STEP -D
4080  IF T% >= V2%(Z) THEN 4110
4090  V2%(Z+D)=V2%(Z): A=Z: GOSUB UNPLOT
4095  A=Z+D: GOSUB PLOT
4100  NEXT Z
4110  V2%(Z+D)=T%: A=Z+D: GOSUB PLOT
4120  NEXT Y
4130  D=INT(D/2): IF D > 0 THEN 4030
4140  RETURN
5000  '------------------------------
5010  QUICK:
5020  SS=1: SL(1)=1: SR(1)=N
5030  L=SL(SS): R=SR(SS): SS=SS-1
5040  Y=L: Z=R
5050  X%=V2%((Y+Z)/2)
5060  IF V2%(Y) < X% THEN Y=Y+1: GOTO 5060
5070  IF X% < V2%(Z) THEN Z=Z-1: GOTO 5070
5080  IF Y > Z THEN 5110
5090  GOSUB SWITCH
5100  Y=Y+1: Z=Z-1
5110  IF Y <= Z THEN 5060
5120  IF Y < R THEN SS=SS+1: SL(SS)=Y: SR(SS)=R
5130  R = Z
5140  IF L < R THEN 5040
5150  IF SS <> 0 THEN 5030
5160  RETURN
6000  '-----------------------------
6010  SWITCH:
6020  A=Y: GOSUB UNPLOT
6030  A=Z: GOSUB UNPLOT
6040  SWAP V2%(Y), V2%(Z)
6050  A=Y: GOSUB PLOT
6060  A=Z: GOSUB PLOT
6070  RETURN
6080  '
6100  UNPLOT:
6110  COLOR 1,1,0
6120  GOSUB PLOT
6130  COLOR 1,1,1
6140  RETURN
6150  '
6200  PLOT:
6210  XX=INT(A*Xconst)+OFFSET
6220  YY=Yconst - V2%(A)+50
6230  LINEF XX, YY, XX, YY
6240  RETURN
6250  '
7000  '-----------------------------
7010  READY:
7020  GOTOXY 1,2: PRINT"Press [RETURN] to begin sorting:"SPACE$(6);
7030  INPUT "", X$: PRINT   'Wait for input
7040  GOTOXY 1,2: PRINT SPACE$(40)
7050  RETURN
7100  '-----------------------------
7110  RANDARRAY:
7120  RANDOMIZE 0
7130  FOR Z=1 TO N
7140  V1%(Z)=INT(RND*Yconst)
7150  NEXT
7160  RETURN
7200  '-----------------------------
7210  CENTERPRINT:
7220  GOTOXY INT(36-LEN(A$)/2), VTAB
7230  PRINT A$: RETURN
7300  '-----------------------------
7310  SETSTYLE:
7320  POKE CONTRL, PARM
7330  POKE CONTRL+2, 0
7340  POKE CONTRL+6, 1
7350  POKE INTIN, STYLE
7360  VDISYS
7370  RETURN
7400  '-----------------------------
7410  PLOTRAND:
7420  LINEF OFFSET-2, 48, OFFSET-2, 162     ' Draw box
7430  LINEF OFFSET-2, 162, OFFSET+144, 162  '
7440  LINEF OFFSET+144, 162, OFFSET+144, 48 '
7450  LINEF OFFSET+144, 48, OFFSET-2, 48    '
7460  FOR Z=1 TO N
7470  XX=INT(Z*Xconst)+OFFSET: YY=Yconst- V1%(Z)+50
7480  LINEF XX, YY, XX, YY
7490  NEXT Z
7500  RETURN
7600  '-----------------------------
7610  SND:
7620  SOUND 1,12,5,5,10
7630  SOUND 1,12,1,5,10
7640  SOUND 1,0,0,0,0
7650  RETURN
7990  '-----------------------------
9000  INITIALIZE:
9010  SORTNAME$(0)=" Bubble Sort"
9020  SORTNAME$(1)="Insertion Sort"
9030  SORTNAME$(2)="   Shellsort"
9040  SORTNAME$(3)="   Quicksort"
9050  CLEARW 2: FULLW 2: CLEARW 2
9060  VTAB=1: A$="VISUAL  SORT  DEMO"
9070  PARM=107: STYLE=10:  GOSUB SETSTYLE   'Large size
9080  PARM=106: STYLE=2^4: GOSUB SETSTYLE   'Outline style
9090  GOSUB CENTERPRINT
9100  PARM=107: STYLE=9:   GOSUB SETSTYLE   'Reset normal size
9110  PARM=106: STYLE=0:   GOSUB SETSTYLE   'Reset normal style
9120  WHILE N<20 OR N>200
9130  GOTOXY 1,2: INPUT" How many random plot points? (20-200) ",N$
9140  N=VAL(N$)
9150  WEND
9160  Xconst=140/N: Yconst=110
9170  DIM V1%(N): DIM V2%(N)
9180  DIM SL(N), SR(N)
9190  RETURN
